import { Board, Entity, Profession } from "./type";
import { Coordinate } from "./coordinate";
import { Side } from "./side";
export declare function get_entity_from_coord<T>(board: Readonly<(T | null)[][]>, coord: Coordinate): T | null;
export declare function delete_en_passant_flag(board: Board, coord: Coordinate): void;
/**
 * 駒・碁石・null を盤上の特定の位置に配置する。can_castle フラグと can_kumal フラグを適宜調整する。
 * @param board
 * @param coord
 * @param maybe_entity
 * @returns
 */
export declare function put_entity_at_coord_and_also_adjust_flags(board: Board, coord: Coordinate, maybe_entity: Entity | null): Entity | null;
export declare function lookup_coords_from_side_and_prof(board: Readonly<Board>, side: Side, prof: Profession): Coordinate[];
export declare function lookup_coords_from_side(board: Readonly<Board>, side: Side): Coordinate[];
