"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const index_1 = require("./index");
const board_1 = require("./board");
test('get_entity_from_coord_gold', () => {
    expect((0, board_1.get_entity_from_coord)((0, index_1.get_initial_state)("黒").board, ["４", "九"]))
        .toEqual({ type: "しょ", side: "黒", prof: "金", can_kumal: false });
});
test('get_entity_from_coord_queen', () => {
    expect((0, board_1.get_entity_from_coord)((0, index_1.get_initial_state)("黒").board, ["５", "八"]))
        .toEqual({ type: "ス", side: "黒", prof: "ク", never_moved: true });
});
test('get_entity_from_coord_gold', () => {
    expect((0, board_1.get_entity_from_coord)((0, index_1.get_initial_state)("黒").board, ["５", "九"]))
        .toEqual({ type: "王", side: "黒", prof: "キ", never_moved: true, has_moved_only_once: false });
});
test('get_entity_from_coord_throw', () => {
    expect(() => (0, board_1.get_entity_from_coord)((0, index_1.get_initial_state)("黒").board, ["ク", "トゥ"]))
        .toThrowError("座標「クトゥ」は不正です");
});
test('get_entity_from_coord_throw', () => {
    expect(() => (0, board_1.get_entity_from_coord)((0, index_1.get_initial_state)("黒").board, ["５", "百"]))
        .toThrowError("座標「５百」は不正です");
});
test('get_entity_from_coord_throw', () => {
    expect(() => (0, board_1.put_entity_at_coord_and_also_adjust_flags)((0, index_1.get_initial_state)("黒").board, ["５", "百"], { type: "しょ", prof: "成桂", side: "黒", can_kumal: false }))
        .toThrowError("座標「５百」は不正です");
});
test('lookup_coord', () => {
    expect((0, board_1.lookup_coords_from_side_and_prof)((0, index_1.get_initial_state)("黒").board, "黒", "ビ")).toEqual([
        ["３", "八"],
        ["７", "八"],
    ]);
});
test('piece_move', () => {
    const board = (0, index_1.get_initial_state)("黒").board;
    const king = (0, board_1.get_entity_from_coord)(board, ["５", "九"]);
    (0, board_1.put_entity_at_coord_and_also_adjust_flags)(board, ["５", "九"], null);
    (0, board_1.put_entity_at_coord_and_also_adjust_flags)(board, ["４", "八"], king);
    const king2 = (0, board_1.get_entity_from_coord)(board, ["４", "八"]);
    expect(king2).toEqual({
        type: "王", side: "黒", prof: "キ",
        never_moved: false, has_moved_only_once: true
    });
    (0, board_1.put_entity_at_coord_and_also_adjust_flags)(board, ["４", "八"], null);
    (0, board_1.put_entity_at_coord_and_also_adjust_flags)(board, ["５", "九"], king2);
    expect((0, board_1.get_entity_from_coord)(board, ["５", "九"])).toEqual({
        type: "王", side: "黒", prof: "キ",
        never_moved: false, has_moved_only_once: false
    });
    const lance = (0, board_1.get_entity_from_coord)(board, ["１", "九"]);
    (0, board_1.put_entity_at_coord_and_also_adjust_flags)(board, ["１", "九"], null);
    (0, board_1.put_entity_at_coord_and_also_adjust_flags)(board, ["５", "四"], lance);
    expect((0, board_1.get_entity_from_coord)(board, ["５", "四"])).toEqual({ type: "しょ", side: "黒", prof: "香", can_kumal: false });
    const queen = (0, board_1.get_entity_from_coord)(board, ["５", "八"]);
    (0, board_1.put_entity_at_coord_and_also_adjust_flags)(board, ["５", "八"], null);
    (0, board_1.put_entity_at_coord_and_also_adjust_flags)(board, ["５", "五"], queen);
    expect((0, board_1.get_entity_from_coord)(board, ["５", "五"])).toEqual({ type: "ス", side: "黒", prof: "ク", never_moved: false });
});
