import { Coordinate } from "./coordinate";
import { Side } from "./side";
import { Board } from "./type";
/**
 * `o.from` に駒があってその駒が `o.to` へと利いているかどうかを返す。ポーンの斜め利きは常に can_see と見なす。ポーンの2マス移動は、駒を取ることができないので「利き」ではない。
 *  Checks whether there is a piece at `o.from` which looks at `o.to`. The diagonal move of pawn is always considered. A pawn never sees two squares in the front; it can only move to there.
 * @param board
 * @param o
 * @returns
 */
export declare function can_see(board: Readonly<Board>, o: {
    from: Coordinate;
    to: Coordinate;
}): boolean;
export declare function do_any_of_my_pieces_see(board: Readonly<Board>, coord: Coordinate, side: Side): boolean;
